;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-intermediate-reader.ss" "lang")((modname starfleet) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f () #f)))
(require "extras.rkt")
(require rackunit)

;; A Spaceship is represented as one of two structs:
;; (make-mothership (name crew daughters))
;; -- which represents a mother ship
;; (make-drone)
;; -- which represents a drone
;; INTERPRETATION:
;;  name      : String        is the name of the ship
;;  crew      : MartianList   is the list of crewmembers of the ship
;;  daughters : ShipList      is the list of daughter ships

;; IMPLEMENTATION:
(define-struct mothership (name crew daughters))
(define-struct drone ())

;; CONSTRUCTOR TEMPLATES:
;; (make-mothership String MartianList ShipList)
;; (make-drone)

;; Template
;; ship-fn : Spaceship -> ??
#;
(define (ship-fn s)
  (cond
    [(mothership? s) 
     (... (mothership-name s)
          (martian-list-fn (mothership-crew s))
          (ship-list-fn    (mothership-daughters s)))]
    [(drone? s) 
     ...]))


;; A ShipList is either - 
;; -- empty
;; -- (cons Spaceship ShipList)

;; Template
;; ship-list-fn : ShipList -> ??
#;
(define (ship-list-fn los)
  (cond
    [(empty? los) ...]
    [else (... (ship-fn (first los))
               (ship-list-fn (rest los)))]))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; A Martian is represented as a
;; (make-martian name)
;; INTERPRETATION
;; name : String   is the name of the martian

;; IMPLEMENTATION
(define-struct martian (name))

;; CONSTRUCTOR TEMPLATE
;; (make-martian String)

;; OBSERVER TEMPLATE
;; martian-fn : Martian -> ??
#;
(define (martian-fn m)
  (... (martian-name m)))


;; A MartianList is one of - 
;; -- empty
;; -- (cons Martian (MartianList))
;; Template
;; martian-list-fn : MartianList -> ??
#;
(define (martian-list-fn ms)
  (cond 
    [(empty? ms) ...]
    [else (... (martian-fn (first ms))
               (martian-list-fn (rest ms)))]))


;; an example. 

(define ship1
  (make-mothership "qwerk"
    ;; the crew
    (list
      (make-martian "hork")
      (make-martian "bork")
      (make-martian "quork"))
    ;; the daughters
    (list
      (make-mothership "berk"
        (list
          (make-martian "alfalfa")
          (make-martian "balfalfa")
          (make-martian "Mork"))
        (list
          (make-drone)
          (make-mothership "little-berk"
            empty
            empty)
          (make-mothership "little-berk2"
            (list
              (make-martian "jork")
              (make-martian "dork")
              (make-martian "Mork"))
            empty)))
      (make-mothership "herk"
        (list
          (make-martian "peon")
          (make-martian "deon"))
        empty))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Q1: Given a spaceship, how many Martians named "Mork" are in the crew of either the spaceship or its fleet?

;;; Note: these are mutually recursive, so I've merged their headers and written the function definitions
;;; together


;; ship-mork-count : Spaceship -> NonNegInt
;; RETURNS: the number of Martians named "Mork" in the crew of the spaceship or its fleet
;; shiplist-mork-count : ShipList -> NonNegInt
;; RETURNS: the total of number of Martians named "Mork" in the crew of these ships or their fleets
;; STRATEGY: Observer template for Spaceship and ShipList

(define (ship-mork-count s)
  (cond
    [(drone? s) 0]
    [(mothership? s)
     (+ (crew-mork-count (mothership-crew s))
        (shiplist-mork-count (mothership-daughters s)))]))

(define (shiplist-mork-count ss)
  (cond
    [(empty? ss) 0]
    [else (+ (ship-mork-count (first ss))
             (shiplist-mork-count (rest ss)))]))

;; This is a help function-- it doesn't call any of the other functions

;; crew-mork-count : MartianList -> NonNegInt
;; GIVEN: a list of Martians
;; RETURNS: the number of Martians in the list that are named Mork.
(define (crew-mork-count ms)
  (cond
    [(empty? ms) 0]
    [(string=? "Mork" (martian-name (first ms)))
     (+ 1 (crew-mork-count (rest ms)))]
    [else (crew-mork-count (rest ms))]))


(begin-for-test
  (check-equal? (ship-mork-count ship1) 2))
      
